<?php
    // DCThread: http://www.donationcoder.com/Forums/bb/index.php?topic=5910.msg41711#msg41711
    $progname = "TouchFiles";
    print "\nAnalyzing commandline parameters ...";
    $datadir = $argv[1];
    if(!chdir($datadir))
	print_usage("Cannot change to directory \"".$datadir."\"");
    list($year, $mon, $day) = explode("/", $argv[2]);
    $year = (int) $year;
    $mon = (int) $mon;
    $day = (int) $day;
    if(!checkdate($mon, $day, $year))
	print_usage("Invalid Date!");
    list($hour, $min, $sec) = explode(":", $argv[3]);
    $hour = (int) $hour;
    $min = (int) $min;
    $sec = (int) $sec;
    if($hour > 23 || $hour < 0 || $min > 59 || $min < 0 ||
       $sec > 59 || $sec < 0)
    {
	print_usage("Invalid Time!");
    }
    $at = mktime($hour, $min, $sec, $mon, $day, $year);
    $anz = 0;
    $files = array();
    
    print "\nTouching starts...Please wait!";
    
    print "\nCaching files...";
    $dldir = opendir($datadir);
    while(($aktdl = readdir($dldir)) !== FALSE)
    {
        // . and .. and own Programname
	// entries should not be touched
	if($aktdl == "." || $aktdl == ".." ||
	   $aktdl == "$progname.php" ||
	   $aktdl == "$progname.exe" ||
	   is_dir($aktdl))
	{
		continue;
	}
	$files[] = $aktdl;
    }
    closedir($dldir);
    
    print "\nSorting Files ...";
    natcasesort($files);
    
    print "\nTouching Files ...";
    $anz = 0;
    while(list($key, $value) = each($files))
    {
	print "\nTouching File \"".$value."\" to Date: ".
	      date("Y/m/d", $at)." Time: ".date("H:i:s", $at)." ... ";
	if(touch($value, $at, $at))
	{
	    print "OK!";
	    $at = $at + 60;
	    $anz++;
	}
	else
	    print "FAILED!";
    }
    
    print "\nFinished! $anz Files touched!\n";
    
    function print_usage($msg = "")
    {
	global $progname;
	
	$emsg = "\n$progname V 1.0 (C)2006 by JoToSoft, Stuttgart\n\n".
	        "This program was a request by IconBoy. A member of\n".
	        "Donaticoder (http://www.donationcoder.com)\n\n".
	        "This program changes the access and modification timestamps\n".
	        "of the files in a SourceDir according to StartDate/StartTime,\n".
	        "and increments StartTime by 1 minute for every file in natural\n".
	        "alphabetic order\n\n".
	        "Usage: $progname <SourceDir> <StartDate> <StartTime>\n\n".
	        "<SourceDir> = Absolute Path to Directory that contains the Files to Touch\n".
		"              (e.g. C:\MyPictures\vacations)\n".
	        "<StartDate> = Date in the Format YYYY/MM/DD that the files\n".
	        "              should begin to be set to (e.g. 2006/12/24)\n".
	        "<StartTime> = Time in 24 hour Format HH:MM:SS that the files\n".
	        "              should be start to set and incremented by\n".
	        "              1 minute for each file (e.g. 10:11:12)\n";
	if(strlen($msg) > 0)
	    $emsg .= "\n--> ERROR: $msg\n";
	exit($emsg);
    }
    
?>